var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var plugin_exports = {};
__export(plugin_exports, {
  MapPlugin: () => MapPlugin,
  default: () => plugin_default
});
module.exports = __toCommonJS(plugin_exports);
var import_server = require("@nocobase/server");
var import_path = __toESM(require("path"));
var import_actions = require("./actions");
var import_fields = require("./fields");
var import_value_parsers = require("./value-parsers");
class MapPlugin extends import_server.Plugin {
  afterAdd() {
  }
  beforeLoad() {
    const fields = {
      point: import_fields.PointField,
      polygon: import_fields.PolygonField,
      lineString: import_fields.LineStringField,
      circle: import_fields.CircleField
    };
    this.db.registerFieldTypes(fields);
    this.db.registerFieldValueParsers({
      point: import_value_parsers.PointValueParser,
      polygon: import_value_parsers.PolygonValueParser,
      lineString: import_value_parsers.LineStringValueParser,
      circle: import_value_parsers.CircleValueParser
    });
  }
  async load() {
    await this.importCollections(import_path.default.resolve(__dirname, "collections"));
    this.app.resource({
      name: "map-configuration",
      actions: {
        get: import_actions.getConfiguration,
        set: import_actions.setConfiguration
      },
      only: ["get", "set"]
    });
    this.app.acl.registerSnippet({
      name: `pm.${this.name}.configuration`,
      actions: ["map-configuration:set"]
    });
    this.app.acl.allow("map-configuration", "get", "loggedIn");
  }
  async install(options) {
  }
  async afterEnable() {
  }
  async afterDisable() {
  }
  async remove() {
  }
}
var plugin_default = MapPlugin;
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  MapPlugin
});
